MorphScaleX = -20.0
MorphScaleY = -20.0
MorphScaleZ = -20
ModelScale = 39.3700787

fn align l pos =(
	while pos>=l do pos=pos-l
	return(l-pos)
)

struct MORPHTARGET (
    Unknown1,
    Unknown2,
    TargetCRC,
    Unknown3
)

struct BOUNDINGTARGET (
    DeltaPos,
    VertexCount,
    LargestVertexUsed,
    XMin,
    XMax,
    YMin,
    YMax,
    ZMin,
    ZMax
)

struct MORPHDATA (
	Deltapos,
	Index,
	Normal
)

if Morphtest != undefined then destroydialog Morphtest
rollout Morphtest "Morphtest" (
	local originalpositions = undefined
	local Morphmesh = undefined
	local MorphDatas = #()

	button pick_morph "Pick Morph File" width:150
	pickbutton pick_mesh "Pick Morph Mesh" width:150
	group "scales" (
		spinner scalex "X scale:" type:#float range:[-30,30,-21] scale:0.00001
		spinner scaley "Y scale:" type:#float range:[-30,30,-20] scale:0.00001
		spinner scalez "Z scale:" type:#float range:[-30,30,-20] scale:0.00001
	)
	button apply_morph "Update/Apply" enabled:false width:150
	on pick_morph pressed do (
		cmorph = GetOpenFileName \
		caption:"Saints Row III Morph test" \
		types: "SRIII Morph File (*.cmorph_pc)|*.cmorph_pc|"
		if (cmorph!=undefined) AND ((doesFileExist cmorph)==true) then(
			m = fopen cmorph "rb"

			CRC = readlong m
			unknown1 = readlong m
			for i=1 to (align 16 (ftell m)) do readbyte m --align to 16 bytes
			TargetCRC = readlong m
			unknown2 = readlong m
			unknown3 = readlong m
			MorphTargetCount = readlong m
			MorphTargets = #()
			for i=1 to MorphTargetCount do (
				Target = MORPHTARGET()
				Target.Unknown1 = readlong m
				Target.Unknown2 = readlong m
				Target.TargetCRC = readlong m
				Target.Unknown3 = readlong m
				append MorphTargets Target
			)
			BoundingTargets = #()
			for i=1 to MorphTargetCount do (
				Bound = BOUNDINGTARGET()
				Bound.Deltapos = for i=1 to 3 collect (readfloat m)
				Bound.VertexCount = readshort m
				Bound.LargestVertexUsed = readshort m
				Bound.XMin = readfloat m
				Bound.XMax = readfloat m
				Bound.YMin = readfloat m
				Bound.YMax = readfloat m
				Bound.ZMin = readfloat m
				Bound.ZMax = readfloat m
				append BoundingTargets Bound
			)
			for i=1 to (align 16 (ftell m)) do readbyte m --align to 16 bytes
			MorphDatas = #()
			for i=1 to MorphTargetCount do (
				for j=1 to BoundingTargets[i].VertexCount do (
					MorphItem = MORPHDATA()
					pos = [0.0,0.0,0.0]
					pos.x = readshort m as float
					pos.y = readshort m as float
					pos.z = readshort m as float
					MorphItem.Deltapos = pos
					MorphItem.Index = readshort m
					MorphItem.Normal = for i=1 to 4 collect ((readbyte m #unsigned) as float -128.0) / 128.0
					append MorphDatas MorphItem
				)
			)
			fclose m
			pick_morph.text = filenamefrompath cmorph
		)
	)
	on pick_mesh picked obj do (
		if obj != undefined then (
			pick_mesh.text = obj.name
			morphmesh = obj
			originalpositions = for i=1 to obj.numverts collect polyop.getvert obj i
			apply_morph.enabled = true
		)
	)
	on apply_morph pressed do (
		if morphmesh != undefined then (
			if classof morphmesh == editable_poly then (
				for i=1 to morphmesh.numverts do (
					oldpos = originalpositions[i]
					deltapos = MorphDatas[i].DeltaPos
					newpos = [0.0,0.0,0.0]
					newpos[1] = deltapos.x * (2.0^scalex.value as float) * Modelscale
					newpos[2] = -deltapos.z * (2.0^scaley.value as float) * Modelscale
					newpos[3] = deltapos.y * (2.0^scalez.value as float) * Modelscale
					newpos = oldpos + newpos
					polyop.setvert morphmesh i newpos
				)
			)
		)
	)
)

createdialog Morphtest
